<?php

/**
 * webservice_notificacion_debito actions.
  * Link PRUEBA:: http://soporte14.sofhouse.net/cartera/web/api_dev.php/api/webservice_notificacion_debito/add.json?id_debito=139617&observacion=OBS%20PRUEBA&id_tipo_operacion_deb=1&fecha_proceso=2019-03-25&correo=dortega@sofhouse.net&num_ticket=36
 *
 * @package    cartera
 * @subpackage webservice_notificacion_debito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class webservice_notificacion_debitoActions extends sfQuery
{
 /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_NOTIFICACION_DEBITO',
        'CA_TIPO_OPERACION_DEBITO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CA_TIPO_OPERACION_DEBITO' =>
        array(
            'id_tipo_operacion_deb' => 'CA_NOTIFICACION_DEBITO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_NOTIFICACION_DEBITO' =>
        array(
            'id_notificacion_debito' => 'id_notificacion_debito',
            'id_debito' => 'id_debito',
            'id_tipo_operacion_deb' => 'id_tipo_operacion_deb',
            'fecha_proceso' => 'fecha_proceso',
            'observacion' => 'observacion',
            'correo' => 'correo',
            'num_ticket' => 'num_ticket'
        ),
        'CA_TIPO_OPERACION' =>
        array(
            'descripcion' => 'descripcion',
            'desc_corta' => 'desc_corta',
            'estado' => 'estado_tipope'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CA_NOTIFICACION_DEBITO' => array(
            'id_notificacion_debito,a' => array('!=' => array(-1)),
            'id_notificacion_debito,b' => array('=' => array('id_notificacion_debito')),
            'id_debito' => array('=' => array('id_debito')),
            'num_ticket' => array('=' => array('num_ticket')),
            'id_tipo_operacion_deb' => array('=' => array('id_tipo_operacion_deb')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(

    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_notificacion_debito'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_notificacion_debito'; //identificador de la tabla
    protected $id_names = array('id_notificacion_debito'); //llave primaria
    protected $field_names = array('id_debito', 'id_tipo_operacion_deb', 'fecha_proceso', 'observacion', 'correo', 'num_ticket','usuario_log','fecha_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_NOTIFICACION_DEBITO'; //tabla en la cual se aplican los cambios
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_notificacion_debito'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = 'admin';
            $request['fecha_log'] = CN_TABLE::fechaSistema();   
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Notificar por correo 
            $id_debito = $this->list_data[0]['id_debito'];
            $subject = "Notificacion de Debito: $id_debito";
            $recipients = array(
                array(
                        'email' => sfConfig::get('app_email_envio'),
                        'name' => 'Nota Debito'
                     )
            );
//            $ccRecipients = array(
//                array(
//                        'email' => 'harold.murcia@sofhouse.net',
//                        'name' => 'Test Name'
//                     )
//            );
            
            //cuerpo del mensaje
            $fecha_creacion = CN_TABLE::fechaSistema();
            $num_ticket = $this->list_data[0]['num_ticket'];
            $mensaje_estado = $this->list_data[0]['mensaje_estado'];
            $correo = $this->list_data[0]['correo'];
            $body = <<<EOD
                <html><body> 
                <br/>
                Bogotá, $fecha_creacion
                <br/>
                <br/><br/>
                Por medio de la presente se enviá correo de la notificación al título, según detalles a continuación:</b><br/><br/>
                <b>No. Ticket: </b>$num_ticket<br/>      
                <b>Tipo Operación: </b>$mensaje_estado<br/>      
                <b>Codigo del Título: </b>$id_debito<br/>      
                <b>Correo de Origen: </b>$correo<br/>        
                <br></br>
                </body></html>
EOD;

            CN_TABLE::sendMail($recipients, array(), $subject, $body, array());
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Agrega una fila a la tabla
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            if ($value == 'null') {
                unset($request[$key]);
            }
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /**
         * VALIDAR ERRORES DE PROCEDIMIENTO
         */
        try {

            // Validar operación
            $errors = $this->validateAdd($request);

            /*
             * Validar errors
             */
            if ($errors == null) {

                /**
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $request = $this->preprocessRequest("ADD", $request);

                // Ejecutar la operación normalmente        
                $this->add($request);

                /**
                 * idEstado: Identificador estado generado.
                 * mensajeEstado
                 */
                $this->logMessage("POST ADD LIST DATA*  Ip: ");
                foreach ($this->list_data[0] as $key => $value) {
                    $this->logMessage("request[$key] = $value");
                }
                $this->logMessage("---END POST ADD LIST DATA");
                
                $id_notificacion_debito = $this->list_data[0]['id_notificacion_debito'];

                $sql = <<<EOD
select
nottit.id_notificacion_debito as id_Estado,
tipope.descripcion as mensaje_Estado,
                        
nottit.id_notificacion_debito,
tipope.descripcion,
nottit.id_debito,
nottit.id_tipo_operacion_deb,
nottit.fecha_proceso,
nottit.observacion,
nottit.correo,
nottit.num_ticket                        
from ca_notificacion_debito nottit
left join ca_tipo_operacion_debito tipope
on tipope.id_tipo_operacion_deb = nottit.id_tipo_operacion_deb

where
nottit.id_notificacion_debito = $id_notificacion_debito 
EOD;

                $this->list_data = CN_TABLE::executeSQL($sql);

                /**
                 * Acciones posteriores a la original
                 * 
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $this->postprocessRequest("ADD", $request, $this->list_data);
            } else {

                /*
                 * Validar que errors es un array con datos
                 */
                if (is_array($errors)) {
                    $errors['operacion'] = "ADD";
                    $this->list_errors = $errors;
                }

                // Devolver los errores vía Json
                if (isset($errors['mensaje'])) {
                    $mensaje = "[ADD sfAPIActions] " . $errors['mensaje'];
                } else {
                    $mensaje = "[ADD sfAPIActions] ERROR !!!";
                }


                $this->logMessage($mensaje);
                $this->logMessage("status -1");

                $this->status = $this->STATUS_FAILURE;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
            }
        } catch (Doctrine_Connection_Exception $e) {

            $mensaje = "[ADD sfAPIActions] ERROR Doctrine_Connection_Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'mensaje' => $mensaje,
                'operacion' => "ADD"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        } catch (Exception $e) {

            $mensaje = "[ADD sfAPIActions] ERROR Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'operacion' => "ADD"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        }
    }
}
